import { ChainGunSear } from './ChainGunSear';
interface UserReference {
    alias: string;
    pub: string;
}
interface AckErr {
    err: Error;
}
interface UserCredentials {
    priv: string;
    epriv: any;
    alias: string;
    pub: string;
    epub: string;
}
declare type LoginCallback = (userRef: UserReference | AckErr) => void;
export declare class ChainGunUserApi {
    is?: UserReference;
    private _gun;
    private _signMiddleware?;
    constructor(gun: ChainGunSear);
    /**
     *
     * https://gun.eco/docs/User#user-create
     *
     * @param alias
     * @param password
     * @param cb
     * @param opt
     */
    create(alias: string, password: string, cb?: LoginCallback, opt?: {}): Promise<{
        alias: string;
        pub: string;
    }>;
    /**
     *
     * https://gun.eco/docs/User#user-auth
     *
     * @param alias
     * @param password
     * @param cb
     * @param opt
     */
    auth(alias: string, password: string, cb: LoginCallback, opt?: {}): Promise<{
        alias: string;
        pub: string;
    }>;
    /**
     * https://gun.eco/docs/User#user-leave
     */
    leave(): void;
    useCredentials(credentials: UserCredentials): {
        alias: string;
        pub: string;
    };
}
export {};
